#pragma once

#ifdef _MSC_VER
#define inline
#include <stdio.h>
#include <windows.h>
#define SIMULATOR 1
#else
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#define SIMULATOR 0
#endif

#include "types.h"

// Synth Declarations
#define	WAVET_SIZE		64
#define SAMPLE_RATE		44100 // Hz
#define	LCD_RATE		500
#define	CONTROL_RATE	100 // Hz
#define LCD_RATE		500
#define NUM_CHANNELS	1 // voice
#define DRUM_CHAN		-1 // index
#define NUM_WAVES		1
#define CPU_SPEED		20000000
#define F_CPU			CPU_SPEED
#define LED_EVENTS		0
#define UNISON_CENT		15.0
#define UNISON_VOICES	1 // max 4
#define MIDI_NOTE_OFFSET	21
#define MIDI_HIGHEST_NOTE	105
#define SMPLS_PER_LCD	(SAMPLE_RATE / LCD_RATE)
#define LCD_PER_CTRL	(LCD_RATE / CONTROL_RATE)

void control();
void preprocess();

extern u8 ctrl_cnt;


// LEDs
#define LED_RED			4	//0b0100	// PORTC
#define LED_GREEN		8	//0b1000

extern u8 red_led_life;
extern u8 green_led_life;

#if SIMULATOR
extern u8 PORTC;
extern u8 synth_shutdown;
u8 TIMER0_COMPA_vect();
#endif

#define LED_RED_ON(ds) {PORTC |= LED_RED; red_led_life = ds * (CONTROL_RATE / 10);}
#define LED_GREEN_ON(ds) {PORTC |= LED_GREEN; green_led_life = ds * (CONTROL_RATE / 10);}
