#pragma once

// MSVSC doesn't like the 0b prefix
#define LCD_COMMAND		0	//0b0		// PORTC
#define LCD_CHAR		1	//0b1
#define LCD_ENABLE		2	//0b10
#define LCD_DISABLE		0	//0b00
#define LCD_LOCSEL		16	//0b10000
#define LCD_ON			24	//0b00011000 // PORTD
#define LCD_2LINE		120	//0b01111000
#define LCD_CLEAR		2	//0b00000010
#define LCD_SCROLL_L	48	//0b00110000
#define LCD_SCROLL_R	56	//0b00111000
#define LCD_SEL_LINE2	64	//0x40
#define LCD_LAST_CHAR	87	//0x57
#define LCD_LINE2		(LCD_LAST_CHAR - 22)
#define LCD_INCREMENT	12	//0b1100
#define LCD_DECREMENT	8	//0b1000 // Prints in reverse

// Printing state can be changed only if the lcd is not busy
void lcd_print_menu(char *str);
void lcd_print_values(u8 v0, u8 v1, u8 v2, u8 v3, u8 signed_vals);
void lcd_init();
void lcd_update();
u8   lcd_busy();
void lcd_set_carret(u8 pos);

extern u8 lcd_reprint_all_values;
