#pragma once
#include "declarations.h"

// Settings
#define MIDI_NEVER_OVERFLOW 0
#define MIDI_CMD_BUFFER 8

// Messages
#define MIDI_NOTE_OFF		8
#define MIDI_NOTE_ON		9
#define MIDI_PRESSURE		0xA
#define MIDI_CONTROL		0xB
#define MIDI_PATCH			0xC
#define MIDI_C_PRESSURE		0xD
#define MIDI_PITCH_BEND		0xE
#define MIDI_STATUS			0xF

// Controls
#define MIDI_CTRL_MODULATION	 1
#define MIDI_CTRL_BREADTH		 2
#define MIDI_CTRL_VOLUME		 7
#define MIDI_CTRL_SLIDER_1		16
#define MIDI_CTRL_SLIDER_2		17
#define MIDI_CTRL_SLIDER_3		18
#define MIDI_CTRL_SLIDER_4		19
#define MIDI_CTRL_HOLD_PEDAL	64

void midi_update();
void midi_write(u8 status, u8 byte1, u8 byte2);

extern u8 midi_slider[4];
extern u8 midi_debug;